#include <iostream> 
using namespace std;

struct Pema
{
	int e_dhena;       t dhnat e nyjes
	Pema* majtas;      nn pema e majt
	Pema* djathtas;    nn pema e djatht
};

Pema *NyjeRe(int vlera)
{
	Pema *nyje = new Pema;
	nyje->e_dhena = vlera;
	nyje->majtas = NULL;
	nyje->djathtas = NULL;

	return nyje;
}

Pema* insertoNyje(Pema *nyja, int vlera)
{
	static Pema *p;
	Pema *retNyje;

	if (nyja == NULL)
	{
		retNyje = NyjeRe(vlera);
		return retNyje;
	}
	if (vlera <= nyja->e_dhena)
	{
		p = nyja;
		nyja->majtas = insertoNyje(nyja->majtas, vlera);
	}
	else
	{
		p = nyja;
		nyja->djathtas = insertoNyje(nyja->djathtas, vlera);
	}
	return nyja;
}

void inOrder(Pema *n)Prshko nnpemn e majt, rrnjen, nnpemn e djatht
{
	if (n)
	{
		inOrder(n->majtas);
		cout << n->e_dhena << " ";
		inOrder(n->djathtas);
	}
}

void preOrder(Pema *n) Prshko rrnjen, nnpemn e majt, nnpemn e djatht
{
	if (n)
	{
		cout << n->e_dhena << " ";
		preOrder(n->majtas);
		preOrder(n->djathtas);
	}
}

void postOrder(Pema *n)Prshko nnpemn e majt, nnpemn e djatht, rrnjen
{
	if (n)
	{
		postOrder(n->majtas);
		postOrder(n->djathtas);
		cout << n->e_dhena << " ";
	}
}

int madhPemes(Pema *nyja)
{
	if (nyja == NULL) 
		return 0;
	else
		return madhPemes(nyja->majtas) + madhPemes(nyja->djathtas) + 1;
}

int nrGjetheve(Pema* nyje)
{
	if (nyje == NULL)
		return 0;
	if (nyje->majtas == NULL && nyje->djathtas == NULL)
		return 1;
	else
		return nrGjetheve(nyje->majtas) + nrGjetheve(nyje->djathtas);
}

int MinMaxThellesi(Pema *nyja, bool min_max)
{
	if (nyja == NULL || (nyja->majtas == NULL && nyja->djathtas == NULL))
		return 0;

	int majThellesi = MinMaxThellesi(nyja->majtas, min_max);
	int djaThellesi = MinMaxThellesi(nyja->djathtas, min_max);

	if (min_max) true max
		return majThellesi > djaThellesi ? majThellesi + 1 : djaThellesi + 1;
	else
		return majThellesi < djaThellesi ? majThellesi + 1 : djaThellesi + 1;
}

void gjejRrugen(Pema* nyja, int rruga[], int level)
{
	if (nyja == NULL) 
		return;

	if (nyja->majtas == NULL && nyja->djathtas == NULL)
	{
		rruga[level] = nyja->e_dhena;
		int sum = 0;
		for (int i = 0; i <= level; i++)
		{
			cout << rruga[i] << " ";
			sum += rruga[i];
		}
		cout << "  distanca = " << sum << endl;
		return;
	}

	rruga[level] = nyja->e_dhena;
	gjejRrugen(nyja->majtas, rruga, level + 1);
	gjejRrugen(nyja->djathtas, rruga, level + 1);
}

